#ifndef _RXDHLINK_H_WRAP_
#define _RXDHLINK_H_WRAP_

#include <RxJoint.h>

class RxDHJoint : public RxJoint
{
protected:
	double alpha_;
	double theta_;
	double a_;
	double d_;
	double ct, st;
	double ca, sa;
public:
//	void copy (const RxDHJoint &link);

	void setParams (double d, double theta, double a, double alpha);
	void getParams (double *dp, double *thetap, double *ap,
			double *alphap) const;

	RxDHJoint (int dof) : RxJoint (dof, dof)
	 { theta_ = 0;
	   a_ = 0;
	   alpha_ = 0;
	   d_ = 0;
//	   A_.setIdent();
	 }
#if 0
	RxDHJoint (double d, double theta, double a, double alpha)
	 { setParams (d, theta, a, alpha);
	 }
#endif
	void setTheta (double theta)
	 { theta_ = theta;
	   st = sin(theta);
	   ct = cos(theta);
	 }
	double getTheta () const
	 { return (theta_);
	 }

	void setD (double d)
	 { d_ = d;
	 }
	double getD () const
	 { return (d_);
	 }

	int oscanField (class RxParseObj *obj);
	int cprintFields (class RxCoutput *co,class RxPrintSpec *ps) const;

	virtual int oscan (class RxParseObj *obj);
	virtual int cprint(class RxCoutput *co,class RxPrintSpec *ps) const;
};

#endif
