#ifndef _RXDHPARAMS_H_WRAP_
#define _RXDHPARAMS_H_WRAP_

#include <RxPrintable.h>
#include <RxTrsf.h>

class RxDHParams : public RxPrintable
{
	double d_;
	double theta_;
	double a_;
	double alpha_;
public:
	void set (double d, double theta, double a, double alpha)
	 {  d_ = d;
	   theta_ = theta;
	   a_ = a;
	   alpha_ = alpha;
	 }

	RxDHParams ()
	 { set (0, 0, 0, 0);
	 }
	RxDHParams (double d, double theta, double a, double alpha)
	 { set (d, theta, a, alpha);
	 }
	double d() const
	 { return d_;
	 }
	double &d()
	 { return d_;
	 }
	double theta() const
	 { return theta_;
	 }
	double &theta()
	 { return theta_;
	 }
	double a() const
	 { return a_;
	 }
	double &a()
	 { return a_;
	 }
	double alpha() const
	 { return alpha_;
	 }
	double &alpha()
	 { return alpha_;
	 }

	void getTrsf (RxTrsf &T);

	virtual int oscan (class RxParseObj *obj);
	virtual int cprint(class RxCoutput *co,class RxPrintSpec *ps) const;
};

#endif

