#ifndef _RXFACE3_H_WRAP_
#define _RXFACE3_H_WRAP_

#include <RxCvxPrim3.h>
#include <RxVrtx3.h>
#include <RxEdge3.h>
#include <RxDlist.h>
#include <RxPlane3.h>

class RxFace3 : public RxCvxPrim3
{
	friend class RxCvxPolyhed3;
	friend class PolyTree;

	int sides;     // number of edges around boundary
	char *name_;
public:
#define RX_FACE3_ID	3
	static const int ID;

	RxPlane3 plane;
	RxSedg3List selist;

	RxFace3()
	 { name_ = NULL;
	   type_ = ID;
	 }
	~RxFace3();

	const char *name() const
	 { return name_;
	 }
	const char *typeName() const
	 { return "Face3";
	 }

	void projectToPlane (class RxCvxPolygon2 *poly, 
		      const RxTrsf &TP, int ccw) const;

	int scan (FILE *fp);
	int xscan (FILE *fp);
	int scan (const char *buf, int *cntp=NULL);
	int scan (class RxCinput *ci);
	int scan ()
	 { return this->scan (stdin);
	 }
	int print (FILE *fp, const char *fmt) const;
	int print (char *buf, const char *fmt) const;
	int print (char *buf, int n, const char *fmt) const;
	int print (class RxCoutput *co, class RxPrintSpec *ps) const;
	int print(const char *fmt) const
	 { return this->print(stdout, fmt);
	 }

	ostream &print(ostream &os) const;
	istream &read(istream &is);
};

class RxFace3ListNode : public RxDnodeBase
{
public:
	RxFace3 f;
	RX_DNODE_DECLS (RxFace3ListNode);
};

typedef RxDlist<RxFace3ListNode> RxFace3List;

inline ostream &operator<<(ostream &os, const RxFace3 &p)
{
	return p.print(os);
}

inline istream &operator>>(istream &is, RxFace3 &p)
{
	return p.read(is);
}

#endif
