#ifndef _RXLINKINFO_H_WRAP_
#define _RXLINKINFO_H_WRAP_

#include <RxTrsf.h>
#include <RxFrameNode.h>
#include <RxRigidLink.h>
#include <RxJoint.h>
#include <RxDlist.h>

class RxLinkInfo : public RxDnodeBase
{
	friend class RxLinkPath;
	friend class RxFrameNode;

	RxTrsf TPJ;	// xform from the parent to the joint frame
	RxRigidLink *link;
	RxJoint *joint;
	RxSpatialAccel a;
	RxTwist v;
	RxSpatialInertia Si;

	RX_DNODE_DECLS (RxLinkInfo);
	RX_FAST_ALLOC_DECLS_L(RxLinkInfo,next_);
};

//typedef RxDlist<RxLinkInfo> RxLinkPath;

class RxLinkPath : private RxDlistBase
{
	void freeNode(void *ptr)
	 { RxLinkInfo::free ((RxLinkInfo*)ptr);
	 };
	int testNode(const RxDnodeBase *node, const void *ptr)
	 { return (((RxLinkInfo*)node)->compare(ptr));
	 };
    public:
	RxLinkPath() : RxDlistBase()
	 {
	 }
	int build (const RxFrameNode *node, 
		   const RxFrameNode *base, RxFastAlloc **availp);

	void clear(RxFastAlloc **availp);

	RxLinkInfo* head()
	 { return (RxLinkInfo*)head_;
	 };
	RxLinkInfo* tail()
	 { return (RxLinkInfo*)tail_;
	 };
	const RxLinkInfo* head() const
	 { return (RxLinkInfo*)head_;
	 };
	const RxLinkInfo* tail() const
	 { return (RxLinkInfo*)tail_;
	 };
};


#endif
