#ifndef _RX_MATBASE_H_
#define _RX_MATBASE_H_

#include <stdio.h>
#include <stdiox.h>
#include <iostream.h>
#include <RxPrintable.h>

class RxMatdBase : public RxPrintable
{
	static double dum;

    protected:
	int doInvert (const RxMatdBase &m1);

    public:

	RxMatdBase ()
	 {
	 };
	
	virtual int nrows() const
	 { return 0;
	 }
	virtual int ncols() const
	 { return 0;
	 }
	virtual double *buf() const
	 { return 0;
	 }
	virtual double *buf(int *) const
	 { return 0;
	 }
#if 0
	virtual int scan (FILE *fp=stdin);
	virtual int xscan (FILE *fp);
	virtual int scan (const char *buf, int *cntp=NULL);
	virtual int scan (class RxCinput *ci);
	virtual istream &scan(istream &is);
#endif
	virtual int oscan (class RxParseObj *obj);

#if 0
	virtual int print (FILE *fp, const char *fmt) const;
	virtual int print (const char *fmt) const
	 { return (print (stdout, fmt));
	 };
	virtual int print (char *buf, const char *fmt, int n=0) const;
	virtual ostream &print(ostream &os) const;
#endif
	virtual int cprint (class RxCoutput *co, class RxPrintSpec *fs) const;

	virtual double& operator()(int, int)
	 { return (dum);
	 }
	virtual double operator()(int, int) const
	 { return (dum);
	 }

	virtual int equal (const RxMatdBase& m2, double eps) const;
	virtual double& elem(int i, int j);
	virtual double elem(int i, int j) const;
};

inline ostream &operator<<(ostream &os, const RxMatdBase &v)
{
	return v.print(os);
}

inline istream &operator>>(istream &is, RxMatdBase &v)
{
	return v.scan(is);
}

#endif
