#ifndef _RXMATDCHOL_H_WRAP_
#define _RXMATDCHOL_H_WRAP_

#include <RxMatd.h>

#define RX_CHOL_DEFAULT_EPS	(1e-13)

class RxMatdChol
{
	friend class RxMatd;

	void doChol (const RxMatd &A);

	double tol;
#define RX_CHOL_CALCDONE	0x01
#define RX_CHOL_L_MALLOCED	0x02
#define RX_CHOL_BADMATRIX	0x08
	int flags;
	int n;

	RxMatd *L;
public:
	// initialization

	int calc (const RxMatd &A);
	int setL (RxMatd *Lm);

	void setTol (double eps)
	 { tol = eps;
	 }
	void getL (RxMatd **Lm)
	 { *Lm = L;
	 }
	RxMatd *getL()
	 { return (L);
	 }
	double getTol () const
	 { return (tol);
	 }
	void copyL (RxMatd *L) const;

	// constructors 

	RxMatdChol ()
	 { L = NULL;
	   tol = RX_CHOL_DEFAULT_EPS;
	   flags = 0;
	 }
	RxMatdChol (const RxMatd &A, RxMatd *Lm=NULL,
		  double eps=RX_CHOL_DEFAULT_EPS)
	 { L = NULL;
	   flags = 0;
	   setL (Lm);
	   tol = eps;
	   calc (A);
	 }
	~RxMatdChol ();

	RxVecd &solve (RxVecd *x, const RxVecd &b) const;
	RxMatd &solve (RxMatd *X, const RxMatd &B) const;
	double condest(const RxMatd &A) const;
	double det() const;

	RxMatd &inv (RxMatd *M) const;
};

#endif
