#ifndef _RXOBJREF_H_WRAP_
#define _RXOBJREF_H_WRAP_

#include <RxHashTab.h>
#include <mutexdefs.h>

class RxObjRef
{
private:
	static MUTEX mux;
public:
	RxObjRef()
	 { 
	 }
//	~RxObjRef();

	virtual void *newObj() const = 0;

	void *getObj (RxPtrHashTab &htab) const
	 { void *ptr;
	   MUTEX_LOCK(&mux);
	   ptr = htab.find (this);
	   if (ptr == NULL)
	    { ptr = newObj();
	      htab.insert (this, ptr);
	    }
	   MUTEX_UNLOCK (&mux);
	 }
};

#endif
