#ifndef _RXPRISM_H_WRAP_
#define _RXPRISM_H_WRAP_

#include <RxCvxPolyhed3.h>

class RxPrism : public RxCvxPolyhed3
{
protected:
	double len;
	int nsides_;
	int differentBottom;
	void init();
public:
	static const int ID;

	RxPrism() : RxCvxPolyhed3()
	 { init();
	 }
	RxPrism(double len, double *topPnts, double *botPnts, int n)
	 { init();
	   set (len, topPnts, botPnts, n);
	 }
	RxPrism(double len, double *topPnts, int n)
	 { init();
	   set (len, topPnts, n);
	 }
	
	void set (double len, double *topPnts, double *botPnts, char *soft,int n);
	void set (double len, double *topPnts, double *botPnts, int n)
	 { set (len, topPnts, topPnts, (char*)0, n);
	 }
	void set (double len, double *topPnts, int n)
	 { set (len, topPnts, topPnts, (char*)0, n);
	 }

	double length()
	 { return len;
	 }
	int getTopPnts (double *buf, int n);
	int getBotPnts (double *buf, int n);

	int nsides()
	 { return nsides_;
	 }

	virtual int oscan (class RxParseObj *obj);
	virtual int cprint (class RxCoutput *co, class RxPrintSpec *ps) const;
};

#endif
