#ifndef _RXTRANS_H_WRAP_
#define _RXTRANS_H_WRAP_

#include <RxTrsf.h>
#include <RxTrsfObj.h>
#include <mutexdefs.h>

class RxTrans : private RxTrsfObj
{
private:
	RxTrsf T_;
	MUTEX mux;

public:
	static const int ID;

	RxTrans (const RxTrsf &T)
	 { type_ = ID;
	   T_ = T;
	   MUTEX_INIT (&mux);
	 }
	RxTrans ()
	 { type_ = ID;
	   T_.setIdent();
	   MUTEX_INIT (&mux);
	 }

	void set (const RxTrsf &T);
	void get (RxTrsf *T);

	void setPos (const RxVecd3 &p);
	void getPos (RxVecd3 *p);

	void setRot (const RxRot &R);
	void getRot (RxRot *R);

	void setRot (const RxVecd3 &v, double ang);
	void getRot (RxVecd3 *v, double *angp);	
};

#endif
