#ifndef _RXVOLPROPS_H_WRAP_
#define _RXVOLPROPS_H_WRAP_

#include <RxVecd3.h>
#include <RxCvxPolyhed3.h>
#include <RxSpatialInertia.h>
#include <RxTrsf.h>

class RxVolProps
{
private:
	double vol_;
	RxVecd3 mov1_;
	RxVecd3 mov2_;
	RxVecd3 pov_;

	void init();	
public:
	RxVolProps()
	 { init();
	 }

	double vol() const
	 { return vol_;
	 }
	const RxVecd3 &mov1() const
	 { return mov1_;
	 }
	const RxVecd3 &mov2() const
	 { return mov2_;
	 }
	const RxVecd3 &pov() const
	 { return pov_;
	 }

	void clear();
	void set (const RxCvxPolyhed3 &poly);
	void set (const RxVolProps &volp);
	void add (const RxVolProps &volp);

	void xform (const RxVolProps &volp, const RxTrsf &T);
	void Ixform (const RxVolProps &volp, const RxTrsf &T);

	void getInertia (RxSpatialInertia &I, double density);
};

#endif
