#ifndef _FASTMATH_H_WRAP_
#define _FASTMATH_H_WRAP_

#include <math.h>

#ifdef __cplusplus
extern "C" {
#endif

/* table will have three more entries than this */
#define SINCOS_TAB_SIZE	4096
#define SINCOS_TAB_SCALE ((SINCOS_TAB_SIZE)/(2*M_PI))

typedef struct {
	double a0, a1, a2, a3;
} RxSincosTabEnt;

/* table will have three more entries than this */
#define ATAN2_TAB_SIZE	4096
#define ATAN2_TAB_SCALE (ATAN2_TAB_SIZE/2)

typedef struct {
	double a0, a1, a2, a3;
} RxAtan2TabEnt;

#ifdef USE_FASTMATH
double SIN(double);
double COS(double);
void SINCOS(double *sp, double *cp, double a);
double ATAN2(double, double);
#else
#define SIN(x)	sin(x)
#define COS(x)	cos(x)
#define SINCOS(sp,cp,a)	(*(sp) = sin(a), *(cp) = cos(a))
#define ATAN2(y,x)	atan2(y,x)
#endif

#ifdef __cplusplus
}
#endif

#endif
