#ifndef _MATHX_H_
#define _MATHX_H_

#ifdef __cplusplus
extern "C" {
#endif

#ifndef PROTO
#ifndef NO_PROTOTYPES
#define PROTO(x) x
#else
#define PROTO(x) ()
#endif
#endif

#include <math.h>

#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif
#define RTOD	(180/M_PI)
#define DTOR	(M_PI/180)

#define SGN(x)	((x) >= 0 ? 1 : -1)

double square PROTO((double));
double cube PROTO((double));
double fourthPower PROTO((double));
double fourthRoot PROTO((double));
double cartDist PROTO((double, double));
double range180 PROTO((double));
double range360 PROTO((double));
double rangePi PROTO((double));
double range2Pi PROTO((double));
double cartDist3 PROTO((double, double, double));
void swapDouble PROTO((double*, double*));
void swapFloat PROTO((float*, float*));
void swapInt PROTO((int*, int*));
double clipInner PROTO((double, double));
double clipOuter PROTO((double, double));
double flmax PROTO((double, double));
double flmin PROTO((double, double));

#ifdef __cplusplus
}
#endif

#endif
