/* Template program for using the argDef package */

#include <stdio.h>
#include "argDef.h"

#define NUM_COLUMNS	80

ArgDefList *argDefs;
char **argvec;
int printHelp;

main(argc, argv)
int argc;
char **argv;
{
	argDefs = argDefCreate();
	if (argDefAdd (argDefs,
"-help %v,1", &printHelp,
#if 0
/* example entries : */
"-plotRate %lf,(0,),	\"replot rate (Hz.)\"", &plotRate,
"-trace %i,[0,),	\"plot previous positions with given spacing\"", 
			&traceOn,
"-psFileName %s,	\"file name for PostScript plotting\"", &psFileName,
#endif
	   		0) < 0)
	 { fprintf (stderr, "%s\n", argDefErrorStr());
	   exit (1);
	 }
#if 0
	argvec = argv;
	argc--; argv++;
	while (argc > 0)
	 { int n;
	   if ((n = argDefMatch (argDefs, argc, argv)) <= 0)
	    { if (n < 0)
	       { fprintf (stderr, "%s\n", argDefErrorStr());
	       }
	      else
	       { argDefPrintUsage (stderr, argDefs, NUM_COLUMNS);
	       }
	      exit (1);
	    }
	   argc -= n; argv += n;
	 }
	if (printHelp)
	 { argDefPrintHelp (stdout, argDefs);
	   exit (0);
	 }
#else
	argDefParseArgs (argc, argv, argDefs, "fsamp.opt", "-help");
#endif
}
