#include <math.h>
#include "cdefs.h"
#include "mathx.h"

double square(x)
double x;
{
	return (x*x);
}

double cube(x)
double x;
{
	return (x*x*x);
}

double fourthRoot(x)
double x;
{
	return (sqrt(sqrt(x)));
}

double fourthPower(x)
double x;
{
	return (square(x*x));
}

double cartDist (x,y)
double x, y;
{
	return (sqrt(x*x + y*y));
}

double cartDist3 (x,y,z)
double x, y, z;
{
	return (sqrt(x*x + y*y + z*z));
}

double range180(a)
double a;
{
	/* puts an angle in the range -180 < a <= 180 */

	double norm;
	
	norm = a/(2*180);
	norm -= (int)norm;
	if (norm > 0.5)
	 { return (180*(2*(norm-1)));
	 }
	else if (norm <= -0.5)
	 { return (180*(2*(norm+1)));
	 }
	else
	 { return (180*(2*(norm)));
	 }
}

double range360(a)
double a;
{
	/* puts an angle in the range 0 <= a < 360 */

	double norm;

	norm = a/(360);
	norm -= (int)norm;
	if (norm >= 0)
	 { return (360*(norm));
	 }
	else
	 { return (360*(norm+1));
	 }
}

double rangePi(a)
double a;
{
	/* puts an angle in the range -Pi < a <= Pi */

	double norm;
	
	norm = a/(2*M_PI);
	norm -= (int)norm;
	if (norm > 0.5)
	 { return (M_PI*(2*(norm-1)));
	 }
	else if (norm <= -0.5)
	 { return (M_PI*(2*(norm+1)));
	 }
	else
	 { return (M_PI*(2*(norm)));
	 }
}

double range2Pi(a)
double a;
{
	/* puts an angle in the range 0 <= a < 2 Pi */

	double norm;

	norm = a/(2*M_PI);
	norm -= (int)norm;
	if (norm >= 0)
	 { return (2*M_PI*(norm));
	 }
	else
	 { return (2*M_PI*(norm+1));
	 }
}

void swapDouble (dp1, dp2)
double *dp1, *dp2;
{
	double tmp;

	tmp = *dp1;
	*dp1 = *dp2;
	*dp2 = tmp;
}

void swapFloat (dp1, dp2)
float *dp1, *dp2;
{
	float tmp;

	tmp = *dp1;
	*dp1 = *dp2;
	*dp2 = tmp;
}

void swapInt (dp1, dp2)
int *dp1, *dp2;
{
	int tmp;

	tmp = *dp1;
	*dp1 = *dp2;
	*dp2 = tmp;
}

double clipInner (x, eps)
double x, eps;
{
	if (ABS(x) < eps)
	 { return (SGN(x)*eps);
	 }
	else
	 { return (x);
	 }
}

double clipOuter (x, eps)
double x, eps;
{
	if (ABS(x) > eps)
	 { return (SGN(x)*eps);
	 }
	else
	 { return (x);
	 }
}

double flmax(a,b)
double a,b;
{
	return (a > b ? a : b);
}

double flmin(a,b)
double a,b;
{
	return (a < b ? a : b);
}
