/* make a process real-time under Sun4-Solaris */

#ifdef Sun4sol_TARGET

#include <sys/types.h>
#include <sys/priocntl.h>
#include <sys/rtpriocntl.h>
#include <sys/tspriocntl.h>
#include <sys/iapriocntl.h>
#include <sys/lwp.h>
#include <sys/mman.h>
#include <errno.h>
 
id_t schedinfo (name, maxpri)
char *name;
int *maxpri;
{
	pcinfo_t info;
	int nc;

	(void) strcpy (info.pc_clname, name);
	nc = priocntl (0L, 0L, PC_GETCID, (caddr_t)&info);

	if (nc == -1L)
	 { return (-1);
	 }
	if (strcmp ("RT", name) == 0)
	 { rtinfo_t *rtinfop;
	   rtinfop = (rtinfo_t*)&info.pc_clinfo;
	   if (maxpri)
	    { *maxpri = rtinfop->rt_maxpri;
	    }
	 }
	else if (strcmp ("TS", name) == 0)
	 { tsinfo_t *tsinfop;
	   tsinfop = (tsinfo_t*)&info.pc_clinfo;
	   if (maxpri)
	    { *maxpri = tsinfop->ts_maxupri;
	    }
	 }
	else if (strcmp ("IA", name) == 0)
	 { iainfo_t *iainfop;
	   iainfop = (iainfo_t*)&info.pc_clinfo;
	   if (maxpri)
	    { *maxpri = iainfop->ia_maxupri;
	    }
	 }
	else
	 { errno = EINVAL;
	   return (-1);
	 }
	return (info.pc_cid);
}

makeRealtime()
{
	pcparms_t priop;
	rtparms_t *rtparms;
	int rtmaxpri;

	if ((priop.pc_cid = schedinfo ("RT", &rtmaxpri)) == -1)
	 { perror ("schedinfo:");
	   exit (1);
	 }
	rtparms = (rtparms_t*)&priop.pc_clparms;
	rtparms->rt_pri = rtmaxpri-1;
	rtparms->rt_tqsecs = 0;
	rtparms->rt_tqnsecs = 500000000;
	if (priocntl (P_LWPID, _lwp_self(), PC_SETPARMS,
					    (caddr_t)&priop) == -1L)
	 { perror ("priocntl (set):");
	   exit (1);
	 }
	if (mlockall (MCL_CURRENT | MCL_FUTURE) < 0)
	 { perror ("mlockall:");
	   exit (1);
	 }
}

#endif

