#ifndef _RXMUXEDNAMETABLE_H_WRAP_
#define _RXMUXEDNAMETABLE_H_WRAP_

#include <RxHashTab.h>
#include <mutexdefs.h>

class RxMuxedNameTable
{
    private:
	MUTEX mux;
	RxStrHashTab *htab;
	int tabsize;
    public:
	RxMuxedNameTable ()
	 { MUTEX_INIT(&mux);
	   tabsize = 256;
	   htab = NULL;
	 }
	RxMuxedNameTable (int size)
	 { MUTEX_INIT(&mux);
	   tabsize = size;
	   htab = NULL;
	 }

	void createTable (int size);
	int insertEntry (const char *name, void *ptr);
	int deleteEntry (const char *name);
	void *getEntry (const char *name);	
};

#endif
