#ifndef _RXSCANERROR_H_WRAP_
#define _RXSCANERROR_H_WRAP_
#include <RxError.h>

class RxScanError : public RxError
{
	RX_ERROR_DECLS (RxScanError)
	int lineno_;
    public:
	enum {
	   BadInput,
	   BadSyntax,
	   BadValue,
	   EndOfInput,
	};
	RxScanError (int n, const char *fmt, ...);
	RxScanError (int n, int line, const char *fmt, ...);
	RxScanError (int n, int line) : RxError (n)
	 { RX_ERROR_CONSTRUCTOR_CODE ();
	   lineno_ = line;
	 };
	RxScanError ()
	 { RX_ERROR_CONSTRUCTOR_CODE ();
	   lineno_ = 0;
	 }
	int &lineno()
	 { return lineno_;
	 }
};
#endif
