#include <RxSlist.h>
#include <string.h>

int RxSlistBase::removeAll()
{
	int notEmpty;

	notEmpty = (head_ != NULL);
	head_ = NULL;
	tail_ = NULL;
	return notEmpty;
}

int RxSlistBase::removeAndDeleteAll()
{
	RxSnodeBase *node, *nextNode = NULL;
	int cnt = 0;

	for (node=head_; node; node=nextNode)
	 { nextNode = node->next_;
	   freeNode (node);
	   cnt++;
	 }
	head_ = NULL;
	tail_ = NULL;
	return cnt;
}

RxSnodeBase *RxSlistBase::remove(RxSnodeBase* ptr)
{
	RxSnodeBase *node, *last = NULL;

	for (node=head_; node; node=node->next_)
	 { if (node == ptr)
	    { if (last == NULL)
	       { head_ = head_->next_;
		 if (head_ == NULL)
		  { tail_ = NULL;
		  }
	       }
	      else
	       { last->next_ = node->next_;
		 if (last->next_ == NULL)
		  { tail_ = last;
		  }
	       }
	      return (node);
	    }
	   last = node;
	 }
	return (NULL);	
}

//
// RxSlistBase::~RxSlistBase()
// {
//	if (autoDelete) removeAndDeleteAll ();
// }

RxSnodeBase *RxSlistBase::addTail(RxSnodeBase* ptr)
{
	ptr->next_ = NULL;
	if (head_ == NULL)
	 { head_ = ptr;
	 }
	else
	 { tail_->next_ = ptr;
	 }
	tail_ = ptr;
	return (ptr);
}

RxSnodeBase *RxSlistBase::addHead(RxSnodeBase* ptr)
{
	ptr->next_ = head_;
	if (tail_ == NULL)
	 { tail_ = ptr;
	 }
	head_ = ptr;
	return (ptr);
}

RxSnodeBase *RxSlistBase::addAfter(RxSnodeBase* ref, RxSnodeBase* ptr)
{
	if (ref == NULL)
	 { return addHead (ptr);
	 }
	else
	 { if (ref->next_)
	    { ptr->next_ = ref->next_;
	    }
	   else
	    { ptr->next_ = NULL;
	      tail_ = ptr;
	    }
	   ref->next_ = ptr;
	   return (ptr);
	 }
}

RxSnodeBase *RxSlistBase::addBefore(RxSnodeBase* ref, RxSnodeBase* ptr)
{
	RxSnodeBase *node, *last = NULL;

	if (ref == NULL)
	 { return addTail (ptr);
	 }
	else
	 { for (node=head_; node; node=node->next_)
	    { if (node == ref)
	       { if (last == NULL)
		  { return addHead (ptr);
		  }
		 else
		  { last->next_ = ptr;
		    ptr->next_ = node;
		    return (ptr);
		  }
	       }
	      last = node;
	    }
	   return (NULL);	
	 }
}

RxSnodeBase *RxSlistBase::findNodeByPtr (const void *ptr) const
{
	RxSnodeBase *node;

	for (node=head_; node; node=node->next_)
	 { if (node->compare (ptr))
	    { return (node);
	    }
	 }
	return (NULL);
}

RxSnodeBase *RxSlistBase::findNodeByName (const char *name) const
{
	RxSnodeBase *node;

	for (node=head_; node; node=node->next_)
	 { if (strcmp (node->getName(), name) == 0)
	    { return (node);
	    }
	 }
	return (NULL);
}

int RxSlistBase::length () const
{
	RxSnodeBase *node;
	int cnt = 0;

	for (node=head_; node; node=node->next_)
	 { cnt++;
	 }
	return (cnt);
}

RxSnodeBase *RxSnodeBase::getNext(int n)
{
	RxSnodeBase *node, *nextNode;
	int k;

	if (n < 0)
	 { return (NULL);
	 }
	else
	 { node = this;
	   for (k=n; k; k--)
	    { if ((nextNode = node->next_))
	       { node = nextNode;
	       }
	      else
	       { break;
	       }
	    }
	   return (node);
	 }
}
