#include <stdio.h>
#include <math.h>
#include <fastmath.h>
#include <stdlib.h>

double sval[SINCOS_TAB_SIZE+4];
double dsv2[SINCOS_TAB_SIZE+4];

void spline(double *y, double *y2, int n, double yp1, double ypn)
{
	int i,k;
	double p,qn,sig,un,*u;

	u = (double*)malloc(sizeof(double)*(n-1));

	y2[0] = -0.5;
	u[0]=3.0*((y[1]-y[0])-yp1);

	for (i=1;i<n-1;i++)
	 {
	   p=y2[i-1]/2+2.0;
	   y2[i]=-0.5/p;
	   u[i]=(y[i+1]-y[i]) - (y[i]-y[i-1]);
	   u[i]=(6.0*u[i]/2-u[i-1]/2)/p;
	 }

	qn=0.5;
	un=3.0*(ypn-(y[n-1]-y[n-2]));

	y2[n-1]=(un-qn*u[n-2])/(qn*y2[n-2]+1.0);
	for (k=n-2;k>=0;k--)
	 { y2[k]=y2[k]*y2[k+1]+u[k];
	 }
	free(u);
}

main()
{
	int i;

	for (i=-2; i<=SINCOS_TAB_SIZE+1; i++)
	 { sval[i+2] = sin(i/SINCOS_TAB_SCALE);
	 }
	spline (sval, dsv2, SINCOS_TAB_SIZE+4, 
		cos(-2/SINCOS_TAB_SCALE)/SINCOS_TAB_SCALE,
		cos((SINCOS_TAB_SIZE+1)/SINCOS_TAB_SCALE)/SINCOS_TAB_SCALE);

	printf ("#include <fastmath.h>\n\n");
	printf ("RxSincosTabEnt rxSincosTab[SINCOS_TAB_SIZE+3] = {\n");
	for (i=0; i<SINCOS_TAB_SIZE+3; i++)
	 { printf (" { %23.16e, %23.16e, %23.16e, %23.16e }%s\n",
		    sval[i], sval[i+1]-sval[i]-dsv2[i]/3 - dsv2[i+1]/6,
		    dsv2[i]/2, (dsv2[i+1]-dsv2[i])/6,
		    (i<SINCOS_TAB_SIZE+2) ? "," : "");
	 }
	printf (" };\n");
	return (0);
}
