#ifndef _GRF4GLCOMMON_H_WRAP_
#define _GRF4GLCOMMON_H_WRAP_

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _sphereTemplate {
  struct _sphereTemplate *next;
  int nTheta;
  int nPhi;
  float (*pnts)[3];
  float (*pntNormals)[3];
  float (*ctrNormals)[3];
  } SPHERE_TEMPLATE;
	
float *_grf4CrossV3f (float *vr, float *v1, float *v2);
float _grf4DotV3f (float *v1, float *v2);
float *_grf4NormalizeV3f (float *vr, float *v1);
void _grf4PrintV3f (char *fmt, float *v1);
float *_grf4SubtractV3f (float *vr, float *v1, float *v2);
float _grf4MagV3f (float *v1);
float *_grf4MultTrsfV3f(float *vr, TRSF *t1, float *v1);
float *_grf4MultRotV3f(float *vr, TRSF *t1, float *v1);

SPHERE_TEMPLATE *_grf4MakeSphereTemplate(int n);
SPHERE_TEMPLATE *_grf4GetSphereTemplate(int n);

#define SPHERE_IDX(s,t,p) (((t)*((s)->nPhi+1))+(p))

#ifdef __cplusplus
}
#endif

#endif
