#include <RxMathError.h>
#include <RxVecd.h>
#include <RxMatd.h>

RxVecd::RxVecd (const RxVecdBase &v2)
{
	int i;

	len = v2.length();
	v = new double[len];
	malloced = 1;
	for (i=0; i<len; i++)
	 { v[i] = v2(i);
	 }
}

RxVecd::RxVecd (double *dp, int l)
{
	int i;

	len = l;
	v = new double[len];
	for (i=0; i<l; i++)
	 { v[i] = dp[i];
	 }
	malloced = 1;
}

RxVecd& RxVecd::set (const double *dp)
{
	int i;

	for (i=0; i<len; i++)
	 { v[i] = dp[i];
	 }
	return (*this);
}

void RxVecd::get (double *dp)
{
	int i;

	for (i=0; i<len; i++)
	 { dp[i] = v[i];
	 }
}

RxVecd& RxVecd::operator=(const RxMatd &m2)
{
	int i;

	if (m2.nr == 1 && m2.nc == len)
	 { for (i=0; i<len; i++)
	    { v[i] = m2.store[i];
	    }
	 }
	else if (m2.nc == 1 && m2.nr == len)
	 { for (i=0; i<len; i++)
	    { v[i] = m2.store[i*m2.width];
	    }
	 }
	else
	 { RxMathError (RxMathError::BadSize,
			"RxVecd:=: %K\n").raise();
	 }
	return (*this);
}
