#ifndef _CURVEX_H_WRAP_
#define _CURVEX_H_WRAP_

#include <RxTrsf.h>
#include <RxTwist.h>

typedef struct {
	RxVecd3 va[4];	// cubic position coefficients
	RxRot RP[4];	// rotational knots points
	RxVecd3 ra[3];	// rotational axis between knots
	double rd[3];	// rotational distance between knots
	double slast;	// s value at the end of the segment
} CurveSegDef;

class RcCurveXPoint {
	void calcRot (RxRot *RR, RxVecd3 *axisp, double *distp,
		      CurveSegDef *sp, double sl);

	static CurveSegDef *segs;
	static int numSegs;
	static int numRpts;
public:
	RxTrsf X;

	RxTwist ur;
	double dldsr;
	RxTwist ul;
	double dldsl;

	double s0;
	int seg;
	double len;

	static void setSegDefs (RxTrsf *Xp, double *slasts, int ns, int nr=4);

	RcCurveXPoint ()
	 { };
	RcCurveXPoint (double s)
	 { set(s);
	 };
	
	void set (double s);
};

#if 0
RxVecd3 curveGetPoint (RxVecd3 *deriv, double s);
void curveSet (RxVecd3 *pntsA, double sA, RxVecd3 *pntsB);
#endif

#endif
